#!/bin/perl
# it is called in the way
# lookfor.pl str paths
# where str is the str to search, paths is a list of path to search seperated by colon.  
use File::Find;

$str=$ARGV[0];
$paths=$ARGV[1];
@paths=split /:/, $paths;

# list all the .t .ct files in the paths
find(\&wanted, @paths);
sub wanted {
  push(@ctfiles, $File::Find::name) if /^.*\.ct$/;
  push(@tfiles, $File::Find::name) if /^.*\.t$/; 
}

# for t-files the comments may be in the form of 
#    function ...=fun(...)
#    //  ...
#    //  ...
# or
#    function ...=fun(...)
#    /* ...
#       ... */
$/="}";
for $file (@tfiles) {
  open(F, $file);
  while (<F>) {
    ($comments{$2}=$3, $location{$2}=$file) if /^function(.*=\s*|\s*)(\w+)\(.*\n((^\/\/.*\n)+)/m || /^function(.*=\s*|\s*)(\w+)\(.*\n\s*?\/\*((.*\n)*?.*?)\*\//m;
  }
  close(F); 
}

# for ct-file the comments may in the form of 
#    [...]=fun(...)
#    /* ...
#       ... */
for $file (@ctfiles) {
  open(F, $file);
  while (<F>) {
    ($comments{$2}=$3, $location{$2}=$file) if /^\[.*?\](.*=\s*|\s*)(\w+)\(.*\n\/\*((.*\n)+?.*?)\*\//m;
  }
  close(F);
}           

open (MORE, "| more");
foreach $key (sort keys %comments) {
  print MORE $key, " in ", $location{$key}, ":\n", $comments{$key}, "\n\n" if $comments{$key} =~ /$str/i;
}
close(MORE);
