#!/bin/perl
# it is called in the way
# type.pl str paths
# where str is the fun to list, paths is a list of path to search seperated by colon.  
use File::Find;

$str=$ARGV[0];
$paths=$ARGV[1];
@paths=split /:/, $paths;

# list all the .t .ct files in the paths
find(\&wanted, @paths);
sub wanted {
  push(@ctfiles, $File::Find::name) if /^.*\.ct$/;
  push(@tfiles, $File::Find::name) if /^.*\.t$/; 
}

# t-file in the form of 
#    function ...=fun(...)
#    //  ...
#    //  ...
# or
#    function ...=fun(...)
#    /* ...
#       ... */
for $file (@tfiles) {
  open(F, $file);
  while (<F>) {
    if ($_=~ /^function(.*=\s*|\s*)(\w+)\(.*\n/) {
      $location{$2}=$file;
      $noline{$2}=$.;
    }
  }
  close(F); 
}

# ct-file in the form of 
#    [...]=fun(...)
#    /* ...
#       ... */
for $file (@ctfiles) {
  open(F, $file);
  while (<F>) {
    if ($_=~ /^\[.*?\](.*=\s*|\s*)(\w+)\(.*\n/) {
      $location{$2}=$file;
      $noline{$2}=$.;     
    }  
  }
  close(F);
}           

if (defined($location{$str})) {
  @args=("more", "+".$noline{$str}, $location{$str});
  system @args;
}

